//转换页面

var fs = require('fs'),
    path = require('path');
var pageFile = null;
var Wxml = require('./wxml');
var Wxss = require('./wxss');
var chalk = require('chalk');
var debug = require('debug')('wevue');

function readFile(wxFolder, page, rootFolder, ext) {
    var file = path.join(wxFolder, page + ext);
    if (fs.existsSync(file)) {
        return fs.readFileSync(file, 'utf8');
    }
    return null;
}

module.exports = function(wxFolder, vueFolder, page, rootFolder, wevueFolder, cb) {
    debug("convert",page);
    var pathInfo = path.parse(page);
    var vue = pathInfo.name;

    var folder = path.parse(pathInfo.dir).name;


    debug('page wevueFolder', wevueFolder);
    pageFile = path.join(wevueFolder, 'template', "page.vue");

    var wxml = readFile(wxFolder, page, rootFolder, '.wxml');
    var wxss = readFile(wxFolder, page, rootFolder, '.wxss') || "";
    var js = readFile(wxFolder, page, rootFolder, '.js');
    var json = readFile(wxFolder, page, rootFolder, '.json') || '{}';

    if (!wxml) {
        console.log(chalk.red(page + '.wxml不存在'));
        cb(page + '.wxml不存在', null);
        return;
    }



    Wxml(wxml, function(err, xml) {
        var template = fs.readFileSync(pageFile, 'utf8');
        var xml = template.replace('{{XML}}', xml).replace('{{WXSS}}', Wxss(wxss));
        var pageFolder = path.join(vueFolder, 'src', 'pages', folder);
        if (!fs.existsSync(pageFolder)) {
            fs.mkdirSync(pageFolder);
        }

        fs.writeFileSync(path.join(pageFolder, vue + '.vue'), xml);
        if (js) {
            fs.writeFileSync(path.join(pageFolder, vue + '.js'), js);
        }

        if (json) {
            fs.writeFileSync(path.join(pageFolder, vue + '.json'), json);
        }
        cb(err, null);
    });

}
