async function handle(params, ctx, next) {
    var options = {
        har: {
            url: (process.env.FILESTACK_URL || 'http://filestack.qyhub.net') + '/oauth2/token',
            method: 'POST',
            headers: [{
                name: 'content-type',
                value: 'application/x-www-form-urlencoded'
            }],
            postData: {
                mimeType: 'application/x-www-form-urlencoded',
                params: [{
                    name: 'client_id',
                    value: params.client_id
                }, {
                    name: 'client_secret',
                    value: params.client_secret
                }, {
                    name: 'grant_type',
                    value: params.grant_type
                }]
            }
        }
    };

    var response = await ctx.ajax(options);
    if (response.statusCode === 200) {
        let tokenInfo = JSON.parse(response.body);
        ctx.succeed(tokenInfo);
    } else {
        return ctx.succeed({});
    }
}

module.exports = handle;