import Vue from 'vue'
import VueRouter from 'vue-router'
import Vuex from 'vuex'

let path = require('path')

const appConf = require('./app.json')

let sdk = require('wevue-tools')

import AppView from 'promise?bluebird!./layouts/App.vue'

require('layouts/RegPlugins.vue')


let tools = sdk.tools
console.log(sdk,'sdk');
window.shoots=window.wx=sdk.wx;
window.Page = sdk.Page;
window.App = sdk.App;
window.getApp = App.getApp;
window.PVAPP = {};
window.PVCI = {};
window.PVTBI = {};//tabbar实例

window.PVBI = {};//backend实例
window.__wxBackendOptions = {}

window.__wxPageOptionsJar = {}
window.__wxPageOptions = {}
window.__wxAppOptions = {}
window.PagePath = '/';

Vue.config.silent = false
Vue.config.errorHandler = function (err, vm) {
  // handle error
  console.warn(err);
}
Vue.use(VueRouter)
Vue.use(Vuex)

const routes = tools.getAppRouters(appConf)

const store = new Vuex.Store({
    state: {},
    mutations: {
        setData(state,payload){
            Object.assign(state[PagePath.replace(/\//g,'_')],payload)
        }
    },
    actions: {
        setData(ctx,params){
            if('object'!==typeof params){
                return new Error('setData参数必须是一个state对象')
            }
            ctx.commit('setData',params)
        }
    },
    modules:{}
})

const router = new VueRouter({
  routes
})
router.beforeEach((to, from, next) => {
    PagePath = to.path
    var fromStore = ''

    if(from.path!=='/'){
        if(PVAPP){
            if(PVAPP.$store){
                fromStore = from.path.replace(/\//g,'_')
                if(to.path!==from.path){
                    PVAPP.$store.unregisterModule(fromStore)
                }
                __wxPageOptions = __wxPageOptionsJar[PagePath]
            }
        }
    }
    next()
})

router.afterEach(route => {
    if(PVCI._uid){

        tools.pageOnShow(PVCI)
    }
    if(PVTBI._uid){

        tools.resetTabBarData()
    }
})

require('./app.js')  //执行app.js

App.__initApp(function(){
    new Vue({
        store,
        router,
        render:h=>h(AppView),
        created:function(){
            PVAPP = this

            tools.appOnLoad(this)

        },
        mounted:function(){
            tools.appOnShow(this)

        },
        destroyed:function(){
            tools.appOnHide(this)
        }
    }).$mount('#app')
})
